' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -------------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/01/30 
' -------------------------------------------------------------------
'C|[g錾
Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    '
    Const PI As Double = 3.14159265358979

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'rfIݒt@CitpXj
    Private m_strVideoConfFilePath As String

    'GbWo
    Private m_EdgeScanCircle As New FvCircle

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        'Rg[̐ݒ
        cmbEdgeColor.Items.Add("") 'WHITE_TO_BLACK
        cmbEdgeColor.Items.Add("") 'BLACK_TO_WHITE
        cmbEdgeColor.Items.Add("ɐ") 'ALL_COLOR
        cmbEdgeColor.SelectedIndex = 2

        cmbEdgePoint.Items.Add("ő_")  'POINT_PEAK lő̈ʒuGbWƂ܂
        cmbEdgePoint.Items.Add("ŏ̓_") 'POINT_1ST lԍŏɉzʒuGbWƂ܂
        cmbEdgePoint.SelectedIndex = 0

        cmbEdgeStartPos.Items.Add("SO") 'FROM_START n_ʒuGbW܂
        cmbEdgeStartPos.Items.Add("OS") 'FROM_END I_ʒuGbW܂
        cmbEdgeStartPos.SelectedIndex = 0

        cmbOrigin.Items.Add("o~̒S")
        cmbOrigin.Items.Add("GbW狁߂~̒S")
        cmbOrigin.SelectedIndex = 1


        m_blnVideoOpened = False
        btnGrab.Enabled = False

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        'GbWo~̏lݒ
        m_EdgeScanCircle.x = 290
        m_EdgeScanCircle.y = 240
        m_EdgeScanCircle.radius = 120

        ApplyChanges()
        DrawEdgeScanLine()

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - 55
            AxFvxDisplayEx1.Size = newSize
        End If

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'rfIfoCXI[vĂꍇ̓N[Y܂
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    '摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImage1.BitPerPixel <> 8 Or AxFvxImage1.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImage1.BitPerPixel = 8
                AxFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImage1.ImageWidth = 512
                AxFvxImage1.ImageHeight = 480
            End If

            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        End If

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    'o~ݒ
    Private Sub btnSetEdgeScanCircle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetEdgeScanCircle.Click

        Dim intOK As Integer

        'ݒ_CAȌlZbg
        AxFvxROI1.SetCircle(m_EdgeScanCircle)

        'FvxROIgČo~I_CAOo܂
        AxFvxROI1.UseCircle = True
        AxFvxROI1.UsePoint = False
        AxFvxROI1.UseRectangle = False

        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckCircle = 1 Then
            AxFvxROI1.GetCircle(m_EdgeScanCircle)

            ApplyChanges()
            DrawEdgeScanLine()
        End If

    End Sub

    '\XV
    Private Sub btnReDraw_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReDraw.Click

        If ApplyChanges = -1 Then Exit Sub
        DrawEdgeScanLine()

    End Sub

    'o~ƁA̒SLт錟o̕`
    Private Sub DrawEdgeScanLine()

        Dim pLineSeg As New FvLineSegment
        Dim dblRad As Double

        Dim i As Integer

        AxFvxDisplayEx1.ClearOverlay()

        'GbWo`
        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 128, 128)
        AxFvxDisplayEx1.DrawData(0, m_EdgeScanCircle)
        pLineSeg.xs = m_EdgeScanCircle.x
        pLineSeg.ys = m_EdgeScanCircle.y
        dblRad = 2 * PI / AxFvxEdge1.LineNum        'Pʂ̓WA
        For i = 0 To AxFvxEdge1.LineNum - 1
            pLineSeg.xe = pLineSeg.xs + Math.Cos(dblRad * i) * m_EdgeScanCircle.radius
            pLineSeg.ye = pLineSeg.ys + Math.Sin(dblRad * i) * m_EdgeScanCircle.radius
            AxFvxDisplayEx1.DrawData(0, pLineSeg)
        Next

    End Sub

    Private Sub DrawCrossMark(ByVal dbl_x As Double, ByVal dbl_y As Double)

        Dim pLineSeg As New FvLineSegment

        pLineSeg.xs = dbl_x - 5
        pLineSeg.ys = dbl_y - 5
        pLineSeg.xe = dbl_x + 5
        pLineSeg.ye = dbl_y + 5
        AxFvxDisplayEx1.DrawData(0, pLineSeg)

        pLineSeg.xs = dbl_x + 5
        pLineSeg.ys = dbl_y - 5
        pLineSeg.xe = dbl_x - 5
        pLineSeg.ye = dbl_y + 5
        AxFvxDisplayEx1.DrawData(0, pLineSeg)

    End Sub

    'eRg[ɓ͂ꂽݒl̓Kp
    Private Function ApplyChanges() As Integer

        Dim intTemp(3) As Integer

        ApplyChanges = -1

        Try
            intTemp(0) = Integer.Parse(txtThreshold.Text)
            intTemp(1) = Integer.Parse(txtLineWidth.Text)
            intTemp(2) = Integer.Parse(txtLineNum.Text)
        Catch ex As Exception
            MsgBox("lsł", vbExclamation, "G[")
            Exit Function
        End Try

        'l
        If intTemp(0) < 0 Or intTemp(0) > 200 Then
            MsgBox("臒l 0`200 ̊ԂŐݒ肵Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxEdge1.Thresh = intTemp(0)

        'Е
        If intTemp(1) < 0 Then
            MsgBox("Е0ȏŐݒ肵Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxEdge1.LineWidth = intTemp(1)

        'o
        If intTemp(2) < 1 Or intTemp(2) > 360 Then
            MsgBox("o1`360̊ԂŐݒ肵Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxEdge1.LineNum = intTemp(2)

        AxFvxEdge1.EdgeColor = cmbEdgeColor.SelectedIndex         'GbWɐ
        AxFvxEdge1.StartPosition = cmbEdgeStartPos.SelectedIndex  'o
        AxFvxEdge1.EdgePoint = cmbEdgePoint.SelectedIndex         'GbWʒu

        ApplyChanges = 0

    End Function

    's
    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim pCircle As New FvCircle
        Dim pPointGroup As New FvPointGroup
        Dim pLineSeg As New FvLineSegment

        Dim dblWeight As Double 'oXgd
        'd݂́Af[^̂΂̕W΍1`3{ڈƂĐݒ肵ĂB

        Dim dblTime As Double      '
        Dim intCount As Integer    'GbW
        Dim intErr As Integer      'G[ԍ

        Dim pOrigin As New FvPoint   'GbWƂ̋𑪂_i~̒Sj
        Dim dblDistance As Double    'vZpobt@
        Dim dblMaxDistance As Double 'ő勗
        Dim dblMinDistance As Double 'ŏ
        Dim intMaxDistNo As Integer  'ő勗ƂȂ_̔ԍ
        Dim intMinDistNo As Integer  'ŏƂȂ_̔ԍ

        Dim i As Integer


        AxFvxDisplayEx1.ClearOverlay()
        txtResult.Text = ""

        'p[^KpB
        '̓p[^ɃG[vI
        If ApplyChanges() = -1 Then Exit Sub
        Try
            dblWeight = Double.Parse(txtWeight.Text)
        Catch ex As Exception
            MsgBox("d݂̒lsł", vbExclamation, "G[")
            Exit Sub
        End Try

        'o~`
        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 128, 128)
        AxFvxDisplayEx1.DrawData(0, m_EdgeScanCircle)
        DrawCrossMark(m_EdgeScanCircle.x, m_EdgeScanCircle.y)

        '----------------------------------------------------------------
        'ԌvJn
        AxFvxPerformanceCounter1.StartCount()

        'GbWos
        Try
            AxFvxEdge1.Execute(AxFvxImage1.GetOcx(), m_EdgeScanCircle, intCount)
        Catch ex As Exception
            AxFvxEdge1.GetErrReport(intErr)
            MsgBox(GetEdgeErrMesg(intErr) & " (" & intErr.ToString() & ")", vbExclamation, "G[")
            Exit Sub
        End Try

        'GbWƉ~͐ŕ`
        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)

        'oꂽGbW_W̎擾
        AxFvxEdge1.GetResult(0, pPointGroup)

        'oXĝ߂ɃGbW_WFvxCalcDataɃZbg
        Try
            AxFvxCalcData1.SetPoint(0, pPointGroup)

            For i = 0 To pPointGroup.Count - 1
                'GbW_\
                DrawCrossMark(pPointGroup.Item(i).x, pPointGroup.Item(i).y)
            Next

            '3ȏ̃GbWA~̃oXgs
            If pPointGroup.Count > 2 Then
                AxFvxCalcData1.CalcCircle_Robust(pPointGroup.Count, dblWeight)
                AxFvxCalcData1.CalcCircle_GetResult(pCircle)

                AxFvxDisplayEx1.DrawData(0, pCircle)
                DrawCrossMark(pCircle.x, pCircle.y)

                txtResult.Text = "~S : ( " & VisualBasic.Format(pCircle.x, "0.0") & " , " & VisualBasic.Format(pCircle.y, "0.0") & " )" & _
                                vbCrLf & "~a : " & VisualBasic.Format(pCircle.radius, "0.0")
            Else
                MsgBox("GbWȂ܂", vbExclamation, "GbWo")
                Exit Sub
            End If
        Catch ex As Exception
            AxFvxCalcData1.GetErrReport(intErr)
            If intErr <> 0 Then
                MsgBox(GetCalcDataErrMesg(intErr) & " (" & intErr.ToString() & ")", vbExclamation, "G[")
            Else
                MsgBox(Err.Number & " : " & Err.Description, vbExclamation, "G[")
            End If
        End Try


        'ǂ̉~̒S̋𑪂邩
        If cmbOrigin.SelectedIndex = 0 Then
            'o~̒S
            pOrigin.x = m_EdgeScanCircle.x
            pOrigin.y = m_EdgeScanCircle.y
        Else
            'GbW狁߂_̒S
            pOrigin.x = pCircle.x
            pOrigin.y = pCircle.y
        End If

        '1Ԗڂ̃GbW_ƁA~̒SƂ̋lƂĐݒ
        dblDistance = Math.Sqrt((pOrigin.x - pPointGroup.Item(0).x) ^ 2 + (pOrigin.y - pPointGroup.Item(0).y) ^ 2)
        dblMaxDistance = dblDistance
        dblMinDistance = dblDistance

        For i = 1 To pPointGroup.Count - 1
            '~̒SƁAGbW_Ƃ̋vZ
            dblDistance = Math.Sqrt((pOrigin.x - pPointGroup.Item(i).x) ^ 2 + (pOrigin.y - pPointGroup.Item(i).y) ^ 2)

            'ŏlEől̃sbNAbv
            If dblMaxDistance < dblDistance Then
                dblMaxDistance = dblDistance
                intMaxDistNo = i
            End If
            If dblMinDistance > dblDistance Then
                dblMinDistance = dblDistance
                intMinDistNo = i
            End If
        Next

        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 196, 0)

        'Ső勗_܂ł`
        pLineSeg.xs = pOrigin.x
        pLineSeg.ys = pOrigin.y
        pLineSeg.xe = pPointGroup.Item(intMaxDistNo).x
        pLineSeg.ye = pPointGroup.Item(intMaxDistNo).y
        AxFvxDisplayEx1.DrawData(0, pLineSeg)

        'Sŏ_܂ł`
        pLineSeg.xe = pPointGroup.Item(intMinDistNo).x
        pLineSeg.ye = pPointGroup.Item(intMinDistNo).y
        AxFvxDisplayEx1.DrawData(0, pLineSeg)

        txtResult.Text = txtResult.Text & vbCrLf & "ŏ : " & VisualBasic.Format(dblMinDistance, "0.00") & vbCrLf & _
                            "ő勗 : " & VisualBasic.Format(dblMaxDistance, "0.00")

        '----------------------------------------------------------------
        'ԌvI
        AxFvxPerformanceCounter1.StopCount(dblTime)
        txtResult.Text = "S : " & VisualBasic.Format(dblTime, "0.00ms") & vbCrLf & vbCrLf & txtResult.Text

    End Sub

    Public Function GetEdgeErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetEdgeErrMesg = "G["
            Case 4005
                GetEdgeErrMesg = "p[^Ⴂ܂"
            Case 4006
                GetEdgeErrMesg = "̌^Ⴂ܂"
            Case 4007
                GetEdgeErrMesg = "NULLw肳Ă܂"
            Case 4013
                GetEdgeErrMesg = "̈悪w肳Ă܂"
            Case Else
                GetEdgeErrMesg = "sȃG["
        End Select

    End Function

    Public Function GetCalcDataErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetCalcDataErrMesg = "G["
            Case 1605
                GetCalcDataErrMesg = "p[^Ⴂ܂B"
            Case 1606
                GetCalcDataErrMesg = "̌^Ⴂ܂B"
            Case 1607
                GetCalcDataErrMesg = "NULLw肳Ă܂B"
            Case 1610
                GetCalcDataErrMesg = "̊mۂɎs܂B"
            Case 1650
                GetCalcDataErrMesg = "vZs\łB"
            Case Else
                GetCalcDataErrMesg = "sȃG["
        End Select

    End Function

    Private Sub txtLineNum_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtLineWidth.KeyPress, txtLineNum.KeyPress, txtThreshold.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub

    Private Sub txtWeight_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtWeight.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8) Or (e.KeyChar = Chr(&H2E))) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class
